<?php

class CentralpayotpModuleFrontController extends ModuleFrontController {

  public $module;

  const NOM_MODULE = 'centralpay';
  const CENTRALPAY = '_CENTRALPAY_';

  public function __construct() {
    $this->controller_type = 'modulefront'; //instead of standard controllers’ front

    $this->module = Module::getInstanceByName(Tools::getValue('module')); // an instance of the module is created
    if (!$this->module->active) {
      Tools::redirect('index');
    } //if the module is inactive, the user will be redirected to index.php

    $this->page_name = 'module-' . $this->module->name . '-' . Dispatcher::getInstance()
        ->getController(); //for example: module-belvg_storelocator-search

    parent::__construct();
  }


  public function postProcess() {


  }

  /**
   * Assign template vars related to page content
   *
   * @see FrontController::initContent()
   */
  public function initContent() {

    $this->disableColumns();
    parent::initContent();

    $address = new Address($this->context->cart->id_address_delivery);
    $this->context->smarty->assign(
      [
        'PaRes' => Tools::getValue('PaRes'),
        'email' => $this->context->customer->email,
        'phone' => $address->phone,
        'provider' =>  Configuration::get(self::CENTRALPAY . 'PROVIDER')

      ]
    );
    return $this->setTemplate('module:centralpay/views/templates/front/otp.tpl');


  }


  protected function getModuleDir($data = NULL) {
    $path = _PS_MODULE_DIR_ . $this->module->name . '/views/templates/front/';
    if (!is_null($data)) {
      return _PS_MODULE_DIR_ . $this->module->name . '/views/templates/front/' . $data . '/';
    }

    if (!is_null($data)) {
      throw new PrestaShopException('Template not mapped');
    }

    return $path;
  }

  protected function disableColumns() {
    $this->display_column_left = FALSE;
    $this->display_column_right = FALSE;
    $this->display_footer = TRUE;
    $this->display_header = TRUE;
  }


}