/**
 * Created by Centralpay on 16/05/16.
 */

(function() {
    "use strict";

    var urlCentralpayJs = 'https://test-js.centralpay.net';
    var urlCentralpayApi = 'https://test-api.centralpay.net';

    // Include validation.js
    [
        'js/validation.js'
    ].forEach(function (src) {
        var script = document.createElement('script');
        script.src = urlCentralpayJs + '/' + src;
        script.async = false;
        document.getElementsByTagName("head")[0].appendChild(script);
    });

    var merchantPublicKey;
    var currentForm;
    var defaultHandler = function (status, response) {
        var hasError = false;
        var langError = display.languageCheck(display.tokenErrorMessage, display.endUserLanguage());
        var divErrors = document.querySelector('[data-centralpay="errors"]');
        divErrors.innerHTML = "";
        if (status !== 200) { // Error
            var ulErrors = document.createElement('ul');
            var liErrors;
            if (status === 400) {
                var json = JSON.parse(response);
                if (json && json.errors) { // Bad Request with json response errors
                    for (var key in json.errors) {
                        if(key==='card[*]'){
                            jQuery('#cpay-exp-wrapper').after('<div class="error">'+json.errors[key]+'</div>');
                        }
                        if(key==='card[cvc]'){
                            jQuery('#div_cvv').after('<div class="error">'+json.errors[key]+'</div>');
                        }
                        if(key==='card[number]'){
                            jQuery('#num_carte').after('<div class="error">'+json.errors[key]+'</div>');
                        }
                        /* liErrors = document.createElement('li');
                         liErrors.appendChild(document.createTextNode(json.errors[key]));
                         ulErrors.appendChild(liErrors);*/
                    }
                }
                else {
                    // Other errors
                    liErrors = document.createElement('li');
                    liErrors.appendChild(document.createTextNode(display.tokenErrorMessage[langError]));
                    ulErrors.appendChild(liErrors);
                    hasError = true;
                }
            }
            else {
                // Other errors
                liErrors = document.createElement('li');
                liErrors.appendChild(document.createTextNode(display.tokenErrorMessage[langError]));
                ulErrors.appendChild(liErrors);
                hasError = true;
            }
            if(hasError) {
                divErrors.appendChild(ulErrors);
            }else{

                $('.payment-errors').html('');
            }
            // Re-enable submission
            currentForm.querySelector('[type="submit"]').removeAttribute('disabled');
        }
        else {

         //  alert('ok');
            // Token was created
            var token = JSON.parse(response);
            // Insert cardTokenId in the form
            var inputTokenId = document.createElement('input');
            inputTokenId.setAttribute('type', 'hidden');
            inputTokenId.setAttribute('name', 'cardTokenId');
            inputTokenId.value = token.cardTokenId;
            currentForm.appendChild(inputTokenId);
            // Remove submit event
            currentForm.removeEventListener('submit', defaultHandler);
            // Submit the form

                currentForm.submit();

            }
    };

    var initForm = function() {

        var form = document.querySelector('form[data-centralpay="form"]');
        if (form && form.nodeName === "FORM") {
            $('.payment-errors').html('');
            form.addEventListener('submit', function(e) {

                // Prevent other event listener
                Centralpay.utils.safePreventEvent(e);
                // Disable the submit button of the form to prevent repeated clicks
                form.querySelector('[type="submit"]').setAttribute('disabled', 'disabled');
                if($('#conditions-to-approve').length>0){

                    if(!$("input[name='conditions_to_approve[terms-and-conditions]']").prop('checked')){
                        console.log("toto");
                        jQuery('[type="submit"]').removeAttr('disabled');
                        return false;
                    }


                }

                    Centralpay.card.createToken(form, defaultHandler);


                // Request a token from Centralpay

                return false;
            });
        }
    };

    // Object Centralpay
    this.Centralpay = {};
    // Object card in Centralpay
    this.Centralpay.card = {
        createToken : function (form, handler) {
            currentForm = form;
            var self = this;
            var field, query = '';
            // Construction postData query
            query += 'merchantPublicKey=' + merchantPublicKey;
            if (typeof form == 'object' && form.nodeName == "FORM") {
                var centralpayElements = form.querySelectorAll('[data-centralpay]');
                for (var i = centralpayElements.length-1; i >= 0; i--) {
                    field = centralpayElements[i];
                    if (field.hasAttribute('data-centralpay') && field.getAttribute('data-centralpay') != "errors") {
                        query += '&' + field.getAttribute('data-centralpay') + "=" + encodeURIComponent(field.value).replace(/%20/g,'+');
                    }
                }
            }
            // Ajax call
            var xhr = new XMLHttpRequest();
            xhr.open('POST', urlCentralpayApi + '/v2/rest/cardToken');
            xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
            xhr.onreadystatechange = function() {
                if (xhr.readyState == 4) {
                    handler(xhr.status, xhr.responseText);
                }
            };
            xhr.send(query);
        },
        setMerchantPublicKey : function (key) {
            merchantPublicKey = key;
        }
    };
    // Checks whether a data-centralpay="form" is present in a form of the page, in this case a submit event and a handler will be applied to the form
    // Otherwise the merchant will handle the event submit itself with the creation of the token
    initForm();
}).call(this);
