{*
* 2007-2015 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2015 PrestaShop SA
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*}

{if $mode_test == 1}
    <p class="alert alert-warning">{l s='You are in test mode'  mod='centralpay'}</p>
{/if}

<script>
    var url_form_action = "{$link->getModuleLink('centralpay','cardprocess')|escape:'htmlall':'utf-8'}";
    var alert_cgv = '{l s='You must accept the T&C before confirming your payment'  mod='centralpay'}';
</script>

{if $cards|@count>0}
    {assign var="container_class" value="cpay-double-column"}
{else}
    {assign var="container_class" value="cpay-single-column"}
{/if}
<div class="row {$container_class}" id="div_centralpay">

    {if $cards|@count>0}
        <div class="col-lg-5" id="div_list">
            <input type="hidden" name="from" value="{$smarty.server.HTTP_HOST}{$smarty.server.REQUEST_URI}"/>

            <div class="form-group">
                <h3 class="page-subheading">
                    <span>{l s='Select your card' mod='centralpay'}</span>
                    <span class="img_cards2"><span class="lock pt"></span></span>
                </h3>
                <select name="cardId" class="form-control form-control-select">
                    {foreach from=$cards key=k item=v}
                        <option value="{$v.cardId}"> {$v.first6|substr:0:1}XXX-XXXX-XXXX-{$v.last4} ({$v.commercialBrand}{l s=':' mod='centralpay'}
                            {$v.expirationMonth}/{$v.expirationYear})
                        </option>
                    {/foreach}
                </select>
            </div>
            {if $forcecvc == 1}
           <div class="form-group">
                <label class="sr-only" for="cvv3">{l s='CVC' mod='centralpay'}</label>
                <div class="input-group cpay-cvc-wrapper">
                    <div class="input-group-addon cont-picto"><i class="fa fa-lock"></i></div>
                    <input type="text" class="form-control cvc" id="cvv3" pattern="{literal}[0-9]{3,4}{/literal}"
                           maxlength="4" autocomplete="off" size="4" required name="customerValidationValue"
                           placeholder="{l s='CVC' mod='centralpay'}"/>
                    <a href="javascript:void(0);" class="input-group-addon help" data-hasqtip="0"
                       oldtitle="{l s='3 digits on the back of your card' mod='centralpay'}"
                       title="{l s='3 digits on the back of your card' mod='centralpay'}" aria-describedby="qtip-0">?</a>
                </div>
            </div>
            {/if}

            <br/>
            <div class="submit">
                <button type="submit" id="submit-cart" class="button btn btn-default button-medium"><span>{l s='Buy now' mod='centralpay'}<i class="icon-chevron-right right"></i></span></button>
            </div>

        </div>
        <div class="col-lg-1" style="text-align: center;">
            <h2>{l s='or' mod='centralpay'}</h2>
        </div>
    {/if}

    {if $cards|@count>0}
        {assign var="cpay_new_card_class" value="col-xs-12 col-lg-5"}
    {else}
        {assign var="cpay_new_card_class" value="col-lg-12"}
    {/if}

    <div class="{$cpay_new_card_class}">

    <form action="{$link->getModuleLink('centralpay','transactionprocess')|escape:'htmlall':'utf-8'}" id="payment-form"
          data-centralpay="form" class="box" method="post">

        <input type="hidden" name="currency" value="{$currencyCard}"/>
        <input type="hidden" name="amount" value="{$amount}"/>
        <input type="hidden" name="lang" value="{$language}"/>
        <input type="hidden" name="merchantTransactionId" value="{$idCard}"/>
        <input type="hidden" name="order[country]" value="{$language}"/>
        <input type="hidden" name="order[firstName]" value="{$lastname}"/>
        <input type="hidden" name="order[lastName]" value="{$firstname}"/>
        <input type="hidden" name="from" value="{$smarty.server.HTTP_HOST}{$smarty.server.REQUEST_URI}"/>

        <h3 class="page-subheading clearfix">
            {if $cards|@count>0}
                <span>{l s='New card' mod='centralpay'}</span>
            {/if}
            <span class="img_cards{if $cards|@count>0}2{/if}">
                <span class="visa pt"></span>
                <span class="cb pt"></span>
                <span class="mastercard pt"></span>
                <span class="visa_electron pt"></span>
                <span class="maestro pt"></span>
           </span>
        </h3>

        <div class="payment-errors" data-centralpay="errors"></div>

        {* Adapter la position des champs *}
        {if $cards|@count==0}
            {assign var="cpay_class_fields_container" value="col-lg-6"}
        {else}
            {assign var="cpay_class_fields_container" value=""}
        {/if}

        <div class="row">
            <div class="col-xs-12 {$cpay_class_fields_container} form-group" style="width: 100%">
                <label class="sr-only" for="name">{l s='Cardholder name' mod='centralpay'}</label>
                <div class="input-group">
                    <div class="input-group-addon"><i class="fa fa-user"></i></div>
                    <input type="text" class="form-control" id="name" data-centralpay="card[holderName]"
                           value="{$lastname} {$firstname}" placeholder="{l s='Cardholder name' mod='centralpay'}"/>
                </div>
            </div>
            <div class="col-xs-12 {$cpay_class_fields_container} form-group" style="width: 100%">
                <label class="sr-only" for="email">{l s='Email' mod='centralpay'}</label>
                <div class="input-group">
                    <div class="input-group-addon"><i class="fa fa-envelope"></i></div>
                    <input type="email" class="form-control" id="email" data-centralpay="card[holderEmail]" value="{$email}"
                           data-validate="isEmail" placeholder="{l s='Email' mod='centralpay'}"/>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-xs-12 {$cpay_class_fields_container} form-group" id="num_carte" style="width: 100%">
                <label class="sr-only" for="num">{l s='Card Number' mod='centralpay'}</label>
                <div class="input-group">
                    <div class="input-group-addon"><i class="fa fa-credit-card-alt"></i></div>
                    <input type="text" class="form-control" id="num" size="20" data-centralpay="card[number]"
                           data-minlength="12" maxlength="20"
                           autocomplete="off" placeholder="{l s='Card Number' mod='centralpay'}"/>
                </div>
            </div>

            {* Adapter la position des champs *}
            {if $cards|@count==0}
                {assign var="cpay_class_fields2_container" value="col-lg-3"}
            {else}
                {assign var="cpay_class_fields2_container" value=""}
            {/if}
            <div class="col-xs-6 {$cpay_class_fields2_container} form-group" style="width: 50%">
                <label class="sr-only" for="month">{l s='Expiration (MM/YY)' mod='centralpay'}</label>
                <div class="input-group">
                    <div class="input-group" id="cpay-exp-wrapper">
                        <div class="input-group-addon"><i class="fa fa-calendar-o"></i></div>
                        <input type="text" class="form-control mois" id="month" data-minlength="2" value="" maxlength="2"
                               pattern="{literal}[0-9]{2}{/literal}" autocomplete="off"  size="2"
                               data-centralpay="card[expirationMonth]" placeholder="{l s='MM' mod='centralpay'}"/>
                        <span> / </span>
                        <input type="text" class="form-control annee" id="year" size="4"
                               data-centralpay="card[expirationYear]" pattern="{literal}[0-9]{2}{/literal}"
                               data-minlength="2" maxlength="2" placeholder="{l s='YY' mod='centralpay'}"/>
                    </div>
                </div>
            </div>
            <div class="col-xs-6 {$cpay_class_fields2_container} form-group" style="width: 50%">
                <label class="sr-only" for="cvv2">{l s='CVC' mod='centralpay'}</label>
                <div class="input-group cpay-cvc-wrapper" id="div_cvv">
                    <div class="input-group-addon"><i class="fa fa-lock"></i></div>
                    <input type="text" class="form-control cvc" id="cvv2" name="CVV" pattern="{literal}[0-9]{3,4}{/literal}"
                           maxlength="4" autocomplete="off" size="4" data-centralpay="card[cvc]"
                           placeholder="{l s='CVC' mod='centralpay'}"/>
                    <a href="javascript:void(0);" class="input-group-addon help" data-hasqtip="0"
                       oldtitle="{l s='3 digits on the back of your card' mod='centralpay'}"
                       title="{l s='3 digits on the back of your card' mod='centralpay'}" aria-describedby="qtip-0">?</a>
                </div>
            </div>
        </div>
        <div class="checkbox">
            <label for="saveCard">
                <input type="checkbox" name="saveCard" id="saveCard" value="1"/>
                {l s='Save card' mod='centralpay'}
            </label>
        </div>
        <br/>
        <div class="submit clearfix">
            <button type="submit" id="btn-submit" class="button btn btn-default button-medium">
                <span>{l s='Buy now' mod='centralpay'}<i class="icon-chevron-right right"></i></span>
            </button>
            <div class="cpay-mention">
                {l s='Secure payment by' mod='centralpay'}
                <a href="https://www.centralpay.eu/" target="_blank"
                   oldtitle="{l s='CentralPay is a secure payment solution, PCI-DSS certified.' mod='centralpay'}}"
                   title="{l s='CentralPay is a secure payment solution, PCI-DSS certified.' mod='centralpay'}">CentralPay</a>
            </div>
        </div>
    </form>
</div>
